import java.io.File;
import javax.xml.parsers.*;
import org.w3c.dom.*;

public class InputTest {

	public static void main(String [] args) {

		File file = new File("howto.xml");
		try {
			DocumentBuilder builder = 
				DocumentBuilderFactory.newInstance().newDocumentBuilder();
			Document doc = builder.parse(file);

			NodeList nodes = doc.getElementsByTagName("topic");
			for (int i = 0; i < nodes.getLength(); i++) {
				Element element = (Element) nodes.item(i);

				NodeList title = element.getElementsByTagName("title");
				Element line = (Element) title.item(0);

				System.out.println("Title: " + getCharacterDataFromElement(line));

				NodeList url = element.getElementsByTagName("url");
				line = (Element) url.item(0);
				System.out.println("Url: " + getCharacterDataFromElement(line));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public static String getCharacterDataFromElement(Element e) {

		Node child = e.getFirstChild();

		if (child instanceof CharacterData) {
			CharacterData cd = (CharacterData) child;
			return cd.getData();
		}

		return "?";

	}

}
