import java.io.*;

import org.w3c.dom.*;

import javax.xml.parsers.*;

import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class OutputTest {

	public static void main (String args[]) {
		new OutputTest();
	}

	public OutputTest()  {
		try {

			DocumentBuilderFactory dbfac = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = dbfac.newDocumentBuilder();
			Document doc = docBuilder.newDocument();


			Element root = doc.createElement("root");
			doc.appendChild(root);

			Comment comment = doc.createComment("Just a thought");
			root.appendChild(comment);

			Element child = doc.createElement("child");
			child.setAttribute("name", "value");
			root.appendChild(child);

			Text text = doc.createTextNode("foobazbar");
			child.appendChild(text);

			TransformerFactory transfac = TransformerFactory.newInstance();
			Transformer trans = transfac.newTransformer();
			trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
			trans.setOutputProperty(OutputKeys.INDENT, "yes");

			StringWriter sw = new StringWriter();
			StreamResult result = new StreamResult(sw);
			DOMSource source = new DOMSource(doc);
			trans.transform(source, result);
			String xmlString = sw.toString();

			System.out.println("xml:\n\n" + xmlString);

		} catch (Exception e) {
			System.out.println(e);
		}
	}
}
