import java.io.*;
import java.net.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;

import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class SendToMirage {

	public static void main(String [] args) throws IOException {
		if (args.length != 2) {
			System.out.println("usage: java SendToMirage kin-file host");
			System.exit(1);
		}

		File file = new File(args[0]);
		Socket mirageSocket = null;
		PrintWriter out = null;
		String hostname = args[1];
		String xmlString = "";

		try {
			DocumentBuilder builder = 
				DocumentBuilderFactory.newInstance().newDocumentBuilder();
			Document doc = builder.parse(file);

			TransformerFactory transfac = TransformerFactory.newInstance();
			Transformer trans = transfac.newTransformer();
			StringWriter sw = new StringWriter();
			StreamResult result = new StreamResult(sw);
			DOMSource source = new DOMSource(doc);
			trans.setOutputProperty(OutputKeys.DOCTYPE_PUBLIC, 
					"\"-//Apple//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\"");
			trans.transform(source, result);
			xmlString = sw.toString();

			mirageSocket = new Socket(hostname, 19785);
			out = new PrintWriter(mirageSocket.getOutputStream(), true);

			
		} catch (UnknownHostException e) {
			System.err.println("Don't know host: " + hostname);
			System.exit(1);
		}	catch (IOException e) {
			System.err.println("Couldn't get I/O for " 
													+ hostname + " on port 19785");
		} catch (Exception e) {
			e.printStackTrace();
		}

//		System.out.println("Sending to mirage:\n" + xmlString );
		out.println(xmlString);
		while(true) {}
		//out.close();
		//mirageSocket.close();

	}

	public static String getCharacterDataFromElement(Element e) {

		Node child = e.getFirstChild();

		if (child instanceof CharacterData) {
			CharacterData cd = (CharacterData) child;
			return cd.getData();
		}

		return "?";

	}

}
