import java.util.ArrayList;

public class JointNode {
	public JointNode() {
		//centerOfMass = new double[3];
		children = new ArrayList();
	}

	public JointNode(String s) {
		//centerOfMass = new double[3];
		children = new ArrayList();
		name = s;
	}

	public double theta;
	public double d;
	public double alpha;
	public double r;
	public double qOffset;
	public double min;
	public double max;
	public double mass;
	//public double[] centerOfMass;
	public String name;
	public String model;
	public String material;
	public String iksolver;
	public String type;

	public ArrayList children;

	public String toXMLString() {
		String s = "";
		s += "<dict>\n";
		s += "<key>JointType</key> <string>"+type+"</string>\n";
		s += "<key>θ</key> <real>"+theta+"</real>\n";
		s += "<key>d</key> <real>"+d+"</real>\n";
		s += "<key>α</key> <real>"+alpha+"</real>\n";
		s += "<key>r</key> <real>"+r+"</real>\n";
		s += "<key>Min</key> <real>"+min+"</real>\n";
		s += "<key>Max</key> <real>"+max+"</real>\n";
		s += "<key>Mass</key> <real>"+mass+"</real>\n";
		if (model != null) {
			s += "<key>Model</key> <string>"+model+"</string>\n";
		}
		if (material != null) {
			s += "<key>Material</key> <string>"+material+"</string>\n";
		}
		if (iksolver != null) {
			s += "<key>IKSolver</key> <string>"+iksolver+"</string>\n";
		}
		if (name != null) {
			s += "<key>Name</key> <string>"+name+"</string>\n";
		}
		s+= "</dict>\n";

		int size = children.size();

		if (size > 1) {
			for (int i = 0; i < size; i++) {
		s += "<array>\n" + ((JointNode)(children.get(i))).toXMLString() + "</array>\n";
			}
		}
		else if (size == 1) {
			s += ((JointNode)(children.get(0))).toXMLString();
		}

		return s;
	}

	public String toString() {
		if (name != null) {
			return name;
		} else {
			return "dummy joint";
		}
	}

	public void addChild(JointNode child) {
		children.add(child);
	}
}
