import java.io.File;
import javax.xml.parsers.*;
import org.w3c.dom.*;

import java.util.ArrayList;

import java.io.*;

public class KinParser {

	public KinParser() {}

	public JointNode parse (String fname) {
		File file = new File(fname);
		JointNode j = null;
		try {
			DocumentBuilder builder = 
				DocumentBuilderFactory.newInstance().newDocumentBuilder();
//			builder.setIgnoringComments(true);
			Document doc = builder.parse(file);

//			Node doctype = 
//					doc.getDocumentElement().getChildNodes().item(0);
//System.out.println("doctype? " + doctype.getNodeName());

//			Node plist = doctype.getChildNodes().item(0);
//System.out.println("plist? " + plist.getNodeName());

//			KinNodeList klist = new KinNodeList(plist.getChildNodes());
			KinNodeList klist = new KinNodeList(doc.getDocumentElement().getChildNodes());

			j = parseList(klist);

		} catch (Exception e) {
			e.printStackTrace();
		}

		return j;
	}

	public JointNode parseList(KinNodeList array) throws IOException {
		if (array.getLength() == 0) {
			return null;
		}

		Node n = array.item(0);
		JointNode j;

		if (n.getNodeName().equals("dict")) {
			j = dictToNode(n);
			j.addChild(parseList(array.tail()));
		}
		else if (n.getNodeName().equals("array")) { //n is an array elt
			j = parseList(new KinNodeList(n.getChildNodes()));
		}
		else if (n.getNodeName().equals("#text") || n.getNodeName().equals("#comment")) {
			j = parseList(array.tail());
		}
		else {
			throw new IOException("unkown node! name = " + n.getNodeName());
		}
		return j;
	}

	public JointNode dictToNode(Node n) throws IOException {
		NodeList list = n.getChildNodes();
		JointNode j = new JointNode();
System.out.println("adding new joint:");
		for (int i = 1; i < list.getLength(); i+=4) {
/***
			if (list.item(i).getNodeValue().equals("Name")) {
				j.name = list.item(i+2).getNodeValue();
System.out.println("Name: " + j.name);
			} else if (list.item(i).getNodeValue().equals("θ")) {
				j.theta = Double.parseDouble(list.item(i+1).getNodeValue());
System.out.println("theta: " + j.theta);
			} else if (list.item(i).getNodeValue().equals("d")) {
				j.d = Double.parseDouble(list.item(i+2).getNodeValue());
System.out.println("d : " + j.d);
			} else if (list.item(i).getNodeValue().equals("α")) {
				j.alpha = Double.parseDouble(list.item(i+2).getNodeValue());
System.out.println("alpha: " + j.alpha);
			} else if (list.item(i).getNodeValue().equals("r")) {
				j.r = Double.parseDouble(list.item(i+2).getNodeValue());
System.out.println("r: " + j.r);
			} 
***/
System.out.println(i + ": " + list.item(i).getNodeName());
System.out.println((i+1) + ": " + list.item(i+1).getNodeValue());
System.out.println((i+2) + ": " + list.item(i+2).getNodeName());
System.out.println((i+3) + ": " + list.item(i+3).getNodeValue());

		}
		
		return j;
	}

private class KinNodeList implements NodeList {
	public ArrayList myList;

	public KinNodeList(NodeList list) {
		int size = list.getLength();
		myList = new ArrayList(size);
		for (int i = 0; i < size; i++) {
				myList.add(list.item(i));
		}
	}

	public KinNodeList(ArrayList list) {
		myList = new ArrayList(list);
	}

	public int getLength() { return myList.size(); }
	public Node item(int index) { return (Node)(this.myList.get(index));  }

	public KinNodeList tail () {
		return new KinNodeList(new ArrayList(this.myList.subList(1, this.myList.size())));
	}
}
}

